/////////////////////////////////////////////////////////////////
//     ESP32 & Xiaomi Bluetooth  sensor   Oct. 2020  v1.01     //
//       Get the latest version of the code here:              //
//           http://educ8s.tv/esp32-xiaomi-hack                //
/////////////////////////////////////////////////////////////////


// IMPORTANT
// You need to install this library as well else it won't work
// https://github.com/fguiet/ESP32_BLE_Arduino


#include "SPI.h"

#include "soc/soc.h"
#include "soc/rtc_cntl_reg.h"
#include "esp_system.h"
#include <sstream>

#include <BLEDevice.h>
#include <BLEUtils.h>
#include <BLEScan.h>
#include <BLEAdvertisedDevice.h>

#define SCAN_TIME  30 // seconds
//#define SCAN_TIME  5 // seconds

boolean METRIC = true; //Set true for metric system; false for imperial

BLEScan *pBLEScan;

void IRAM_ATTR resetModule() {
  ets_printf("reboot\n");
  esp_restart();
}

float current_battery = -100;
float  current_humidity = -100;
float  previous_humidity = -100;
float current_temperature = -100;
float previous_temperature = -100;

float current_battery1 = -100;
float  current_humidity1 = -100;
float  previous_humidity1 = -100;
float current_temperature1 = -100;
float previous_temperature1 = -100;

long MJ_HT_V1_Millis = 0;
long LYWSD02_Millis = 0;

class MyAdvertisedDeviceCallbacks : public BLEAdvertisedDeviceCallbacks {
    void onResult(BLEAdvertisedDevice advertisedDevice)
    {
      if (advertisedDevice.haveName() && advertisedDevice.haveServiceData() && !advertisedDevice.getName().compare("MJ_HT_V1")) { // Старый круглый датчик

        MJ_HT_V1_Millis = millis();

        int serviceDataCount = advertisedDevice.getServiceDataCount();
        std::string strServiceData = advertisedDevice.getServiceData(0);

        uint8_t cServiceData[100];
        char charServiceData[100];

        strServiceData.copy((char *)cServiceData, strServiceData.length(), 0);

        Serial.printf("\n\nAdvertised Device: %s\n", advertisedDevice.toString().c_str());

        for (int i = 0; i < strServiceData.length(); i++) {
          sprintf(&charServiceData[i * 2], "%02x", cServiceData[i]);
        }

        std::stringstream ss;
        ss << "fe95" << charServiceData;



        Serial.print("Payload:");
        Serial.println(ss.str().c_str());

        char eventLog[256];
        unsigned long value, value2;
        char charValue[5] = {0,};
        switch (cServiceData[11]) {
          case 0x04:
            sprintf(charValue, "%02X%02X", cServiceData[15], cServiceData[14]);
            value = strtol(charValue, 0, 16);
            if (METRIC)
            {
              current_temperature = (float)value / 10;
            } else
            {
              current_temperature = CelciusToFahrenheit((float)value / 10);
            }

            Serial.printf("TEMPERATURE_EVENT: %s, %d\n", charValue, value);
            break;
            //  displayTemperature();
            break;
          case 0x06:
            sprintf(charValue, "%02X%02X", cServiceData[15], cServiceData[14]);
            value = strtol(charValue, 0, 16);
            current_humidity = (float)value / 10;
            //                    displayHumidity();
            Serial.printf("HUMIDITY_EVENT: %s, %d\n", charValue, value);
            break;


          case 0x0A:
            sprintf(charValue, "%02X", cServiceData[14]);
            value = strtol(charValue, 0, 16);

            current_battery = (float)value;
            //   displayBattery();

            Serial.printf("BATTERY_EVENT: %s, %d\n", charValue, value);
            break;
          case 0x0D:
            sprintf(charValue, "%02X%02X", cServiceData[15], cServiceData[14]);
            value = strtol(charValue, 0, 16);
            if (METRIC)
            {
              current_temperature = (float)value / 10;
            } else
            {
              current_temperature = CelciusToFahrenheit((float)value / 10);
            }
            //  displayTemperature();
            Serial.printf("TEMPERATURE_EVENT: %s, %d\n", charValue, value);
            sprintf(charValue, "%02X%02X", cServiceData[17], cServiceData[16]);
            value2 = strtol(charValue, 0, 16);
            current_humidity = (float)value2 / 10;
            //  displayHumidity();
            Serial.printf("HUMIDITY_EVENT: %s, %d\n", charValue, value2);
            break;
        }
      }

      //==================================
      if (advertisedDevice.haveName() && advertisedDevice.haveServiceData() && !advertisedDevice.getName().compare("LYWSD02")) { // Часы

        LYWSD02_Millis = millis();

        int serviceDataCount = advertisedDevice.getServiceDataCount();
        std::string strServiceData = advertisedDevice.getServiceData(0);

        uint8_t cServiceData[100];
        char charServiceData[100];

        strServiceData.copy((char *)cServiceData, strServiceData.length(), 0);

        Serial.printf("\n\nAdvertised Device: %s\n", advertisedDevice.toString().c_str());

        for (int i = 0; i < strServiceData.length(); i++) {
          sprintf(&charServiceData[i * 2], "%02x", cServiceData[i]);
        }

        std::stringstream ss;
        ss << "fe95" << charServiceData;

        Serial.print("Payload:");
        Serial.println(ss.str().c_str());

        char eventLog[256];
        unsigned long value1, value3;
        char charValue1[5] = {0,};
        switch (cServiceData[12]) {
          case 0x04:
            sprintf(charValue1, "%02X%02X", cServiceData[16], cServiceData[15]);
            // value1 = strtol(charValue1, 0, 17);
            value1 = strtol(charValue1, 0, 16);
            if (METRIC)
            {
              current_temperature1 = (float)value1 / 10;
            } else
            {
              current_temperature1 = CelciusToFahrenheit((float)value1 / 10);
            }

            Serial.printf("TEMPERATURE1: %s, %d\n", charValue1, value1);
            break;
            //  displayTemperature();
            break;
          case 0x06:
            sprintf(charValue1, "%02X%02X", cServiceData[16], cServiceData[15]);
            value1 = strtol(charValue1, 0, 16);
            current_humidity1 = (float)value1 / 10;
            //                    displayHumidity();
            Serial.printf("HUMIDITY1: %s, %d\n", charValue1, value1);
            break;


          case 0x0A:
            sprintf(charValue1, "%02X", cServiceData[15]);
            value1 = strtol(charValue1, 0, 16);

            current_battery1 = (float)value1;
            //   displayBattery();

            Serial.printf("BATTERY1: %s, %d\n", charValue1, value1);
            break;
        }
      }//============================================
    }
};

void setup() {

  //  tft.begin();

  //Serial.begin(115200);
  Serial.begin(9600);
  Serial.println("ESP32 XIAOMI DISPLAY");

  initBluetooth();

}

void loop() {

  if (millis() - MJ_HT_V1_Millis > 60 * 1000) {
    current_battery = -100;
    current_humidity = -100;
    previous_humidity = -100;
    current_temperature = -100;
    previous_temperature = -100;
  }


  if (millis() - LYWSD02_Millis > 60 * 1000) {
    current_battery1 = -100;
    current_humidity1 = -100;
    previous_humidity1 = -100;
    current_temperature1 = -100;
    previous_temperature1 = -100;
  }

  char printLog[256];
  Serial.printf("Start BLE scan for %d seconds...\n", SCAN_TIME);
  BLEScan* pBLEScan = BLEDevice::getScan(); //create new scan
  pBLEScan->setAdvertisedDeviceCallbacks(new MyAdvertisedDeviceCallbacks());
  pBLEScan->setActiveScan(true); //active scan uses more power, but get results faster
  BLEScanResults foundDevices = pBLEScan->start(SCAN_TIME);
  int count = foundDevices.getCount();
  printf("Found device count : %d\n", count);

  delay(100);
  /*
       Вывод в сериал порт для проекта IoTmanager
  */
  Serial.print("set id1 ");// После ID 1 пробел
  Serial.print(convertFloatToString(current_temperature));
  Serial.print(", id2 ");// запятая , пробел , id2 пробел
  Serial.print(convertFloatToString(current_humidity));// переменная влажности

  Serial.print(", id3 ");
  Serial.print(convertFloatToString(current_battery));
  Serial.println(","); // запятая и перевод строки

     Serial.println(","); // запятая и перевод строки

 
  delay(500);

  Serial.print("set id4 ");// После ID 1 пробел
  Serial.print(convertFloatToString(current_temperature1));
  Serial.print(", id5 ");// запятая , пробел , id2 пробел
  Serial.print(convertFloatToString(current_humidity1));// переменная влажности

  Serial.print(", id6 ");
  Serial.print(convertFloatToString(current_battery1));
  Serial.println(","); // запятая и перевод строки
}

void initBluetooth()
{
  BLEDevice::init("");
  pBLEScan = BLEDevice::getScan(); //create new scan
  pBLEScan->setAdvertisedDeviceCallbacks(new MyAdvertisedDeviceCallbacks());
  pBLEScan->setActiveScan(true); //active scan uses more power, but get results faster
  pBLEScan->setInterval(0x50);
  pBLEScan->setWindow(0x30);
}

String convertFloatToString(float f)
{
  String s = String(f, 1);
  return s;
}

float CelciusToFahrenheit(float Celsius)
{
  float Fahrenheit = 0;
  Fahrenheit = Celsius * 9 / 5 + 32;
  return Fahrenheit;
}
